<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCalendarDay ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCalendarDay
 * @subpackage Arrays
 */
class ArrayOfCalendarDay extends AbstractStructArrayBase
{
    /**
     * The CalendarDay
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\CalendarDay[]
     */
    public $CalendarDay;
    /**
     * Constructor method for ArrayOfCalendarDay
     * @uses ArrayOfCalendarDay::setCalendarDay()
     * @param \App|C\StructType\CalendarDay[] $calendarDay
     */
    public function __construct(array $calendarDay = array())
    {
        $this
            ->setCalendarDay($calendarDay);
    }
    /**
     * Get CalendarDay value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\CalendarDay[]|null
     */
    public function getCalendarDay()
    {
        return isset($this->CalendarDay) ? $this->CalendarDay : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCalendarDay method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCalendarDay method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCalendarDayForArrayConstraintsFromSetCalendarDay(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCalendarDayCalendarDayItem) {
            // validation for constraint: itemType
            if (!$arrayOfCalendarDayCalendarDayItem instanceof \App|C\StructType\CalendarDay) {
                $invalidValues[] = is_object($arrayOfCalendarDayCalendarDayItem) ? get_class($arrayOfCalendarDayCalendarDayItem) : sprintf('%s(%s)', gettype($arrayOfCalendarDayCalendarDayItem), var_export($arrayOfCalendarDayCalendarDayItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CalendarDay property can only contain items of type \App|C\StructType\CalendarDay, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CalendarDay value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\CalendarDay[] $calendarDay
     * @return \App|C\ArrayType\ArrayOfCalendarDay
     */
    public function setCalendarDay(array $calendarDay = array())
    {
        // validation for constraint: array
        if ('' !== ($calendarDayArrayErrorMessage = self::validateCalendarDayForArrayConstraintsFromSetCalendarDay($calendarDay))) {
            throw new \InvalidArgumentException($calendarDayArrayErrorMessage, __LINE__);
        }
        if (is_null($calendarDay) || (is_array($calendarDay) && empty($calendarDay))) {
            unset($this->CalendarDay);
        } else {
            $this->CalendarDay = $calendarDay;
        }
        return $this;
    }
    /**
     * Add item to CalendarDay value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\CalendarDay $item
     * @return \App|C\ArrayType\ArrayOfCalendarDay
     */
    public function addToCalendarDay(\App|C\StructType\CalendarDay $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\CalendarDay) {
            throw new \InvalidArgumentException(sprintf('The CalendarDay property can only contain items of type \App|C\StructType\CalendarDay, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CalendarDay[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\CalendarDay|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\CalendarDay|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\CalendarDay|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\CalendarDay|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\CalendarDay|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CalendarDay
     */
    public function getAttributeName()
    {
        return 'CalendarDay';
    }
}
