<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ExchangeableOriginDestination StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ExchangeableOriginDestination
 * @subpackage Structs
 */
class ExchangeableOriginDestination extends ApiObject
{
    /**
     * The ETTicketFareTargets
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfETTicketFareTarget
     */
    public $ETTicketFareTargets;
    /**
     * The OriginDestinationOrder
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $OriginDestinationOrder;
    /**
     * The RefItinerary
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $RefItinerary;
    /**
     * Constructor method for ExchangeableOriginDestination
     * @uses ExchangeableOriginDestination::setETTicketFareTargets()
     * @uses ExchangeableOriginDestination::setOriginDestinationOrder()
     * @uses ExchangeableOriginDestination::setRefItinerary()
     * @param \App|C\ArrayType\ArrayOfETTicketFareTarget $eTTicketFareTargets
     * @param int $originDestinationOrder
     * @param string $refItinerary
     */
    public function __construct(\App|C\ArrayType\ArrayOfETTicketFareTarget $eTTicketFareTargets = null, $originDestinationOrder = null, $refItinerary = null)
    {
        $this
            ->setETTicketFareTargets($eTTicketFareTargets)
            ->setOriginDestinationOrder($originDestinationOrder)
            ->setRefItinerary($refItinerary);
    }
    /**
     * Get ETTicketFareTargets value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfETTicketFareTarget|null
     */
    public function getETTicketFareTargets()
    {
        return isset($this->ETTicketFareTargets) ? $this->ETTicketFareTargets : null;
    }
    /**
     * Set ETTicketFareTargets value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfETTicketFareTarget $eTTicketFareTargets
     * @return \App|C\StructType\ExchangeableOriginDestination
     */
    public function setETTicketFareTargets(\App|C\ArrayType\ArrayOfETTicketFareTarget $eTTicketFareTargets = null)
    {
        if (is_null($eTTicketFareTargets) || (is_array($eTTicketFareTargets) && empty($eTTicketFareTargets))) {
            unset($this->ETTicketFareTargets);
        } else {
            $this->ETTicketFareTargets = $eTTicketFareTargets;
        }
        return $this;
    }
    /**
     * Get OriginDestinationOrder value
     * @return int|null
     */
    public function getOriginDestinationOrder()
    {
        return $this->OriginDestinationOrder;
    }
    /**
     * Set OriginDestinationOrder value
     * @param int $originDestinationOrder
     * @return \App|C\StructType\ExchangeableOriginDestination
     */
    public function setOriginDestinationOrder($originDestinationOrder = null)
    {
        // validation for constraint: int
        if (!is_null($originDestinationOrder) && !(is_int($originDestinationOrder) || ctype_digit($originDestinationOrder))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($originDestinationOrder, true), gettype($originDestinationOrder)), __LINE__);
        }
        $this->OriginDestinationOrder = $originDestinationOrder;
        return $this;
    }
    /**
     * Get RefItinerary value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRefItinerary()
    {
        return isset($this->RefItinerary) ? $this->RefItinerary : null;
    }
    /**
     * Set RefItinerary value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $refItinerary
     * @return \App|C\StructType\ExchangeableOriginDestination
     */
    public function setRefItinerary($refItinerary = null)
    {
        // validation for constraint: string
        if (!is_null($refItinerary) && !is_string($refItinerary)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($refItinerary, true), gettype($refItinerary)), __LINE__);
        }
        if (is_null($refItinerary) || (is_array($refItinerary) && empty($refItinerary))) {
            unset($this->RefItinerary);
        } else {
            $this->RefItinerary = $refItinerary;
        }
        return $this;
    }
}
