<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TTIExceptionDetailData StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:TTIExceptionDetailData
 * @subpackage Structs
 */
class TTIExceptionDetailData extends AbstractStructBase
{
    /**
     * The keyField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $keyField;
    /**
     * The valueField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $valueField;
    /**
     * Constructor method for TTIExceptionDetailData
     * @uses TTIExceptionDetailData::setKeyField()
     * @uses TTIExceptionDetailData::setValueField()
     * @param string $keyField
     * @param string $valueField
     */
    public function __construct($keyField = null, $valueField = null)
    {
        $this
            ->setKeyField($keyField)
            ->setValueField($valueField);
    }
    /**
     * Get keyField value
     * @return string|null
     */
    public function getKeyField()
    {
        return $this->keyField;
    }
    /**
     * Set keyField value
     * @param string $keyField
     * @return \App|C\StructType\TTIExceptionDetailData
     */
    public function setKeyField($keyField = null)
    {
        // validation for constraint: string
        if (!is_null($keyField) && !is_string($keyField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($keyField, true), gettype($keyField)), __LINE__);
        }
        $this->keyField = $keyField;
        return $this;
    }
    /**
     * Get valueField value
     * @return string|null
     */
    public function getValueField()
    {
        return $this->valueField;
    }
    /**
     * Set valueField value
     * @param string $valueField
     * @return \App|C\StructType\TTIExceptionDetailData
     */
    public function setValueField($valueField = null)
    {
        // validation for constraint: string
        if (!is_null($valueField) && !is_string($valueField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($valueField, true), gettype($valueField)), __LINE__);
        }
        $this->valueField = $valueField;
        return $this;
    }
}
